% Ilustracija efekta prerijske koije
close all;
clear all;

N_preck = 16; % tevilo prek
F=0.02; % faktor, ki je proporcionalen hitrosti vrtenja kolesa
w=2*pi/N_preck*F;

% Nariemo obro na levi del slike
kot=(0:1:360)*2*pi/180;  x=cos(kot);y=sin(kot);
figure; set(gcf,'position',[60 100 1000 600]); 
set(gcf,'MenuBar','none','NumberTitle','off') % odstranimo menu in tevilko grafa
h1 = line(x+0.2 , y, 'Color', [0 0 0], 'Clipping', 'off'); set(h1,'linewidth',4);
hold on;  axis('equal');  axis off

% Isto na desni del slike
h2 = line(x+2.5,y, 'Color', [0 0 0], 'Clipping', 'off'); set(h2,'linewidth',4);

% Nariemo drsnik za spreminjanje frekvence vzorenja
roc2=uicontrol('style','slider','Position',[20 20 30 500],'Max',5,'Value',5);
text(0.9,1.2,'$$\frac{f_{vzor}}{f_{zasuk}}:$$','FontSize',16,'Interpreter','Latex');
roct=text(1.4,1.2,'5.0','FontSize',16,'Interpreter','Latex');

% komentar
text(1.35,-1.2,'$$f_{vzor}$$ je frekvenca zajemanja slik','FontSize',14,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','bottom');
text(1.35,-1.4,'$$f_{zasuk}$$ je frekvenca ponavljanja slike (frekvenca vrtenja/\v{s}tevilo pre\v{c}k)','FontSize',14,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','bottom');

% Kadar spremenimo drsnik, se vrednost izpie
set(roc2,'Callback',strcat('set(roct,''String'',num2str(get(roc2,''value''))),'))

% nariemo gumb za start
roc1=uicontrol('style','pushbutton','string','Poeni kolo','Position',[60 20 90 30],'Callback','Prim01_KoloKocije_callb');

% nariemo preke
rocicaL = nan(N_preck); rocicaD = nan(N_preck); % prealokacija vektorjev
for i=0:1:N_preck-1
    x=[cos(i*2*pi/N_preck);0];
    y=[sin(i*2*pi/N_preck);0];
    rocicaL(i+1)=line(x+0.2, y, 'color',[0 0 0], 'linewidth',3); % leve preke
    rocicaD(i+1)=line(x+2.5, y, 'color',[0 0 0], 'linewidth',3); % e desne preke
end
