% Ilustracija zgibanja - efekta preslikave vijih frekvenc v nije
% Potrebujemo e zvoni zapis v1.wav

clear all;close all
% definiramo decimacijo signala
N_decim=42;

% Preberemo signal iz datoteke wav
[x,Fs,Nbits]=wavread('v1');
Tmax=(length(x)-1)/Fs;

figure
set(gcf,'MenuBar','none','NumberTitle','off') % odstranimo menu in tevilko grafa
axis([0 1 0 1]);
h1 = text(.5,.55,'Predvajam originalni signal.','FontSize',20,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','middle');
text(.5,.45,'Po\v{c}akajte, prosim.','FontSize',20,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','middle','Color', [0 0.5 0]);
axis off
drawnow
% Predvajamo original (z desetkratno amplitudo)
wavplay(10*x,Fs);

% Decimiramo signal (vzamemo vsak 42. vzorec)
y=x(1:N_decim:end);

% Predvajamo decimiran signal
set(h1,'String','Predvajam decimirani signal.');
drawnow
wavplay(10*y,Fs/N_decim);

% Spekter originalnega signala
fx=fft(x);
Nsam_orig = length(x);
delta_f = Fs/Nsam_orig;
f=0:delta_f:(Nsam_orig-1)*delta_f;

% Frekvenca zgibanja:
fold_f=Fs/N_decim/2;

% Frekvenca, ki jo sliimo (ker se preslika simetrino preko frekvence zgibanja)
slisimo_f = 2*fold_f-975

abs_X_omega = abs(fx) / Fs; % komponente X(jw) dobimo iz komponent fft po deljenju z frekvenco vzorenja (teoretina lastnost fft)

plot(f,abs(abs_X_omega),2*[fold_f fold_f],[0 max(abs(abs_X_omega))],'r:',...
    [fold_f fold_f],[0 max(abs(abs_X_omega))],'g:');
axis([0 5000 0 max(abs(abs_X_omega))])
legend('absolutni spekter','frekvenca vzorenja (po decimaciji)','frekvenca zgibanja (po decimaciji')
xlabel('$$f$$ [Hz]','Interpreter','Latex','FontSize',14);
ylabel('$$|X_z(f)|$$','Interpreter','Latex','FontSize',14);
title('Absolutna vrednost Fourierove transformacije signala','Interpreter','Latex','FontSize',16)
