% Ilustracija uma kvantizacije
% Potrebujemo e zvoni zapis c1.wav

clear all;close all
% Definicija tevila bitov zapisa amplitude signala
Nbit_kvant=4;
% Preberemo signal in vzamemo prvih 2^19 vzorcev ter normiramo na interval [-1, 1]
[x,Fs,Nbits]=wavread('c1');   x=x(1:2^19);     x=x/max(abs(x));

% definiramo asovno os
t=0:1/Fs:(length(x)-1)/Fs;

figure
set(gcf,'MenuBar','none','NumberTitle','off') % odstranimo menu in tevilko grafa
axis([0 1 0 1]);
h1 = text(.5,.55,'Predvajam originalni signal.','FontSize',20,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','middle');
text(.5,.45,'Po\v{c}akajte, prosim.','FontSize',20,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','middle','Color', [0 0.5 0]);
axis off
drawnow
% predvajamo original
wavplay(x,Fs);
%
% Kvantiziramo na 2^Nbit_kvant nivojev
x1=(0.5*x+0.5)*(2^Nbit_kvant-1);  y=2*(round(x1)/(2^Nbit_kvant-1))-1;

% Pogreek
e=x-y;

% Predvajamo kvantizirani signal
set(h1,'String','Predvajam kvantizirani signal.');
drawnow
wavplay(y,Fs);

% Predvajamo pogreek = razliko med prejnjima signaloma
set(h1,'String','Predvajam razliko.');
drawnow
wavplay(e,Fs);

% resolucija ekrana
screen_size = get(0, 'ScreenSize');
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran

% Nariimo oba signala
plot(t,x,'b',t,y,'r');
xlabel('$$t$$ [s]','Interpreter','Latex','FontSize',14);
ylabel('$$x_z$$','Interpreter','Latex','FontSize',14);
title('Ilustracija kvantizacije amplitude signala','Interpreter','Latex','FontSize',16)
legend('original','kvantiziran')
% izraunamo varianco napake, ki jo primerjamo s teoretino ocenjeno (q^2/12)
var_sum_kvantizacije_teor = (2/(2^Nbit_kvant-1))^2/12;
var_sum_kvantizacije_prak = var(e);
text(6,-0.8,['Teoreti\v{c}no ocenjena varianca \v{s}uma kvantizacije: ',num2str(var_sum_kvantizacije_teor)], 'FontSize',20,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','middle');
text(6,-0.9,['Prakti\v{c}no ocenjena varianca \v{s}uma kvantizacije: ',num2str(var_sum_kvantizacije_prak)], 'FontSize',20,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','middle');