% Ilustracija izrauna frekvennega odziva zadrevalnika nitega reda

close all;   clear all;

T = 1; % as vzorenja
frek = 0;        % trenutna frekvenca
t = 0:pi/300:10; % zvezni as
tt = 0:T:10;     % diskretni as

y = sin(2*pi*frek*t);   % zvezni signal
yy = sin(2*pi*frek*tt); % vzoreni signal
A = T * sinc(frek*T);
beta = -pi*frek*T;
yyy = A*sin(2*pi*frek*t+beta);   % navidezni zvezni signal na izhodu (amplitudno popravljen in fazno premaknjen)

% nariemo zvezni signal, vzoreni signal in navidezni zvezni signal
figure; set(gcf,'position',[60 130 1000 600],'MenuBar','none','NumberTitle','off')
hax = axes; set(hax,'Units','pixels'); set(hax,'Position', [150 50 800 500]);
h1 = stairs(tt, yy);  set(h1,'linewidth',2);
hold on
h1vzorci = line(tt,yy, 'LineStyle','none', 'Marker','o');
h2 = line(t,y,'LineStyle','-','Color',[0 1 0]);
h3 = line(t,yyy,'LineStyle','-','Color',[1 0 0], 'linewidth',2);
axis([0 10 -1.1 1])

% Nariemo drsnik za spreminjanje frekvence vzorcenja
text(-1.6,1,'$$\frac{f}{f_s}=$$','FontSize',14,'Interpreter','Latex'); 
roct=text(-1,1.,'0.0','FontSize',14,'Interpreter','Latex');

% nariemo gumb za start
roc1=uicontrol('style','pushbutton','string','Narii','Position',[60 20 60 30],'Callback','Prim12_Frekvencni_odziv_ZOH_callb');

% Kadar spremenimo drsnik, se vrednost izpie (na max. 3 decimalke)
roc2=uicontrol('style','slider','Position',[20 20 30 500],'Max',1,'Value',0);
set(roc2,'Callback',strcat('set(roct,''String'',num2str(get(roc2,''value''),3)),'))

% "Legenda"
text(0.1,-1.07,'vhodni zvezni signal','FontSize',14,'Interpreter','Latex','HorizontalAlignment','left','VerticalAlignment','baseline','Color',[0 1 0]);
text(4,-1.07,'vzorci in izhod ZOH','FontSize',14,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','baseline','Color',[0 0 1]);
text(9.8,-1.07,'harmoni\v{c}na aproksimacija izhoda ZOH','FontSize',14,'Interpreter','Latex','HorizontalAlignment','right','VerticalAlignment','baseline','Color',[1 0 0]);

% Opozorilo za prekoraitev polovice frekvence vzorenja
htext = text(5,1.03,'Kr\v{s}itev teorema o vzor\v{c}enju (previsoka frekvenca signala)','FontSize',16,'Interpreter','Latex','HorizontalAlignment','center','VerticalAlignment','bottom','Color',[1 0 0]);
set(htext,'Visible','off')
