% Ilustracija metod za izraun diskretne matrike prehajanja stanj (simbolino in numerino)
clear all; close all

% resolucija ekrana
screen_size = get(0, 'ScreenSize');

% Definiramo matriko
A=[0 1;-4/25 1];

% 1.metoda: Inverzna z transformcija - simbolino
syms z k
AnaK=iztrans(inv(z * eye(size(A)) - A) * z, k);
figure
set(gcf,'MenuBar','none','NumberTitle','off') % odstranimo menu in tevilko grafa
axis off
text(0,1,['$$\mathbf{A}^k=' latex(AnaK) '$$'],'Interpreter','Latex','FontSize',20,'HorizontalAlignment','left','VerticalAlignment','top')
text(1,1,['$$\mathbf{A}^k=\mathbf{A} \cdot \mathbf{A} \cdot \mathbf{A} \cdot \ldots \cdot \mathbf{A}$$'],'Interpreter','Latex','FontSize',20,'HorizontalAlignment','right','VerticalAlignment','top')
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran

% 2.metoda: Numerino
for n=0:5
    % Primerjava analitine in numerine reitve (A^n = A*A*A* ... *A)
    text(0,0.8-0.15*n,['$$\mathbf{A}^' num2str(n) '=' latex(vpa(subs(AnaK,k,n))) '$$'],'Interpreter','Latex','FontSize',16,'HorizontalAlignment','left','VerticalAlignment','top') % simbolino
    text(1,0.8-0.15*n,['$$\mathbf{A}^' num2str(n) '=' latex(vpa(A^n)) '$$'],'Interpreter','Latex','FontSize',16,'HorizontalAlignment','right','VerticalAlignment','top') % numerino
end
