% Ilustracija ravnotenih tok homogenega sistema
clear all
close all
clc

% Generiramo matriko, za katero velja det(A-I) = 0
T = [0.8 0.1;  0.9 0.9]; % transformacijska matrika
I = eye(2); % enotska matrika
AmI=[0 0;0 -0.2]; % matrika z lastnima vrednostma 0 in -0.2
A0 = T \ AmI * T; % matrika z lastnima vrednostma 0 in -0.2
A = I + A0;       % matrika z lastnima vrednostma 1 in 0.8
disp('Lastni vrednosti matrike A:')
eig(A)
disp('Lastni vrednosti matrike (A-I):')
eig(A-I)
disp('Determinanta matrike (A-I):')
det(A-I)

% Prvo zaetno stanje
x0=[1;1];
figure; hold on;
axis([-3 3 -3 3]);
% Simulacija
for n=0:150
    x = A^n * x0;
    roc = plot(x(1),x(2),'b*');
end

% Drugo zaetno stanje
x0=[-2;0];
% Simulacija
for n=0:150
    x = A^n * x0;
    roc = plot(x(1),x(2),'r*');
end
xlabel('$$x_1$$','Interpreter','Latex','FontSize',14);
ylabel('$$x_2$$','Interpreter','Latex','FontSize',14);
title('Odzivi sistema, \v{c}e $\det(\mathbf{A}-\mathbf{I})=0$','Interpreter','Latex','FontSize',16)


% Generiramo matriko, za katero velja det(A-I) != 0
A = 0.8*I + A0;       % matrika z lastnima vrednostma 1 in 0.8
disp('Lastni vrednosti matrike A:')
eig(A)
disp('Lastni vrednosti matrike (A-I):')
eig(A-I)
disp('Determinanta matrike (A-I):')
det(A-I)

% Prvo zaetno stanje
x0=[1;1];
figure; hold on;
axis([-3 3 -3 3]);
% Simulacija
for n=0:150
    x = A^n * x0;
    roc = plot(x(1),x(2),'b*');
end

% Drugo zaetno stanje
x0=[-2;0];
% Simulacija
for n=0:150
    x = A^n * x0;
    roc = plot(x(1),x(2),'r*');
end
xlabel('$$x_1$$','Interpreter','Latex','FontSize',14);
ylabel('$$x_2$$','Interpreter','Latex','FontSize',14);
title('Odzivi sistema, \v{c}e $\det(\mathbf{A}-\mathbf{I}) \neq 0$','Interpreter','Latex','FontSize',16)
