% 

close all
clear all

% resolucija ekrana
screen_size = get(0, 'ScreenSize');

% Line width
lw_narrow = 0.4;
lw_wide = 2;

% Colors
cb = [0 0 0]; % black color
cw = [1 1 1]; % white color
cr = [1 0 0]; % red color
cbl = [0 0 1]; % blue color
cg = [0 0.5 0]; % green color
clightr = [1 0.85 0.85]; % light red color
cgrey = [0.5 0.5 0.5]; % grey color

T1 = 0.4;
T2 = 1;
wr = 1.55;
s = tf('s');
z1 = tf('z',T1); % operator z za sistem s asom vzorenja T1
z2 = tf('z',T2); % operator z za sistem s asom vzorenja T2
Gz = 1 / (s^2 + 0.1*s + 1);
C1 = wr / tan(wr*T1/2);
s1 = C1*(z1-1)/(z1+1); % disk. sistem, ki ga vnesemo v Gz namesto s
H1 = 1 / (s1^2 + 0.1*s1 + 1);
H1 = minreal(H1) % krajanje polov in niel zaradi transformacije
C2 = wr / tan(wr*T2/2);
s2 = C2*(z2-1)/(z2+1); % disk. sistem, ki ga vnesemo v Gz namesto s
H2 = 1 / (s2^2 + 0.1*s2 + 1);
H2 = minreal(H2) % krajanje polov in niel zaradi transformacije

n1 = H1.num{:};
d1 = H1.den{:};
d1 = d1/n1(1)
n1 = n1/n1(1)

n2 = H2.num{:};
d2 = H2.den{:};
d2 = d2/n2(1)
n2 = n2/n2(1)

bodeplot(Gz, 'bo', logspace(-1,1,601))
hold on
bodeplot(H1, 'rx', logspace(-1,log10(pi/T1)-1e-7,601))
bodeplot(H2, 'g*', logspace(-1,log10(pi/T2)-1e-7,601))

l = legend('$G_z(s)$','$H_1(z)$','$H_2(z)$','Location','SouthWest');
set(l, 'interpreter','latex');

set(0,'ShowHiddenHandles','on')

h = findobj(gcf,'String','Frequency  (rad/sec)');
set(h,'String','$\omega$','interpreter','latex','FontSize',12);

h = findobj(gcf,'String','Magnitude (dB)');
set(h,'String','${\cal A}$ [dB]','interpreter','latex','FontSize',12);

% os za prvi graf Bodeja
axes(get(h,'Parent'))
axis([.1 10 -50 25])

h = findobj(gcf,'String','Phase (deg)');
set(h,'String','${\cal B}$ [$^{\circ}$]','interpreter','latex','FontSize',12);

% os za drugi graf Bodeja
axes(get(h,'Parent'))
axis([.1 10  -240 10])

sive_crte = findobj(gcf,'type','line','LineStyle','-','Color',[0 0 0]);
set(sive_crte,'LineWidth',lw_narrow,'Marker','none','LineStyle','-','Color',cgrey);

crte = findobj(gcf,'type','line','Marker','o');
set(crte,'LineWidth',lw_wide,'Marker','none','LineStyle','-','Color',cbl);
crte = findobj(gcf,'type','line','Marker','x');
set(crte,'LineWidth',lw_wide,'Marker','none','LineStyle','-','Color',cr);
crte = findobj(gcf,'type','line','Marker','*');
set(crte,'LineWidth',lw_wide,'Marker','none','LineStyle','-','Color',cg);

set(0,'ShowHiddenHandles','off')

set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran

