% Primerjava razlik pri diskretizaciji z metodo tustin in zoh pri dveh
% asih vzorenja. Primerjava obsega Bodejeve diagrame, impulzne in
% stopnine odzive

clear all
close all

% resolucija ekrana
screen_size = get(0, 'ScreenSize');

% Line width
lw_narrow = 0.4;
lw_wide = 2;

% Colors
cgrey = [0.5 0.5 0.5]; % grey color

Gz = tf(0.1, [1 1]);

H1t = c2d(Gz, 0.1, 'tustin');
H1z = c2d(Gz, 0.1, 'zoh');

figure
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran
impulse(Gz, H1t, H1z, 10*H1t, 10*H1z);
legend('G_z(s)','tustin','zoh','10*tustin','10*zoh')
figure
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran
step(Gz, H1t, H1z);
legend('G_z(s)','tustin','zoh')
figure
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran
bode(Gz, H1t, H1z);


H2t = c2d(Gz, 1, 'tustin');
H2z = c2d(Gz, 1, 'zoh');

figure
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran
impulse(Gz, H2t, H2z);
legend('G_z(s)','tustin','zoh')
figure
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran
step(Gz, H2t, H2z);
legend('G_z(s)','tustin','zoh')
figure
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran
bode(Gz, H2t, H2z);



set(0,'ShowHiddenHandles','on')

for fig=[3,6]
    figure(fig)
    
    h = findobj(gcf,'String','Frequency  (rad/sec)');
    set(h,'String','$\omega$','interpreter','latex','FontSize',12);

    h = findobj(gcf,'String','Magnitude (dB)');
    set(h,'String','${\cal A}$ [dB]','interpreter','latex','FontSize',12);

    % os za prvi graf Bodeja
    axes(get(h,'Parent'))
    axis([.01 100 -50 -10])
    legend('G_z(s)','tustin','zoh')

    h = findobj(gcf,'String','Phase (deg)');
    set(h,'String','${\cal B}$ [$^{\circ}$]','interpreter','latex','FontSize',12);

    % os za drugi graf Bodeja
    axes(get(h,'Parent'))
    axis([.01 100  -190 10])
    legend('G_z(s)','tustin','zoh')

    sive_crte = findobj(gcf,'type','line','LineStyle','-','Color',[0 0 0]);
    set(sive_crte,'LineWidth',lw_narrow,'Marker','none','LineStyle','-','Color',cgrey);

end

set(0,'ShowHiddenHandles','off')
