% Ilustracija nepovezave fazne (ne)minimalnosti zveznih in diskretnih sistemov

clear all
close all

% resolucija ekrana
screen_size = get(0, 'ScreenSize');

%% Zvezni sistem fazno minimalen (trojni integrator) - nima nile na desni
sys=tf(1,[1 0 0 0]);
% Diskretni sistem ima nilo izven kroga enote (pri z = -3.73)
sysd=c2d(sys,0.1);
figure
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran
subplot(221)
pzmap(sys);  % Poli in nile zveznega sistema
title('Lega polov in niel zveznega sistema','FontSize',12)
axis equal
subplot(222)
pzmap(sysd); % Poli in nile diskrtnega sistema
axis equal
title('Lega polov in niel diskretnega sistema','FontSize',12)
subplot(212)
step(sys,1);hold on;step(sysd,'r',1) % stopnini odziv obeh sistemov
title('Stopnini odziv zveznega in diskretnega sistema','FontSize',12)


%% Zvezni sistem fazno neminimalen - ima nilo na desni (pri s = +0.5)
sys=tf([-1 0.5],[1 2 1]);

sysd=c2d(sys,0.1);

figure
set(gcf, 'Position', screen_size); % poveamo graf ez cel ekran
subplot(221)
pzmap(sys);  % Poli in nile zveznega sistema
title('Lega polov in niel zveznega sistema','FontSize',12)
axis equal
subplot(222)
hax2 = gca;
pzmap(sysd); % Poli in nile diskrtnega sistema
axis equal
title('Lega polov in niel diskretnega sistema','FontSize',12)
subplot(212)
hax3 = gca;
set(hax3,'Units','pixels');
pos3 = get(hax3,'Position');
pos3_premaknjen = pos3;
pos3_premaknjen(1) = pos3_premaknjen(1) + 120;
pos3_premaknjen(3) = pos3_premaknjen(3) - 120;
set(hax3,'Position', pos3_premaknjen);
step(sys,8);           % stopnini odziv zveznega sistema
hold on;
y_d = step(sysd,8);    % stopnini odziv diskretnega sistema
h3 = plot(0:0.1:8,y_d,'ro');
grid
title('Stopnini odziv zveznega in diskretnega sistema','FontSize',12)

% Nariemo drsnik za spreminjanje asa vzorenja
pos_drsnik = pos3;
pos_drsnik(3) = 40;
pos_drsnik(4) = pos_drsnik(4)-50;
roc2=uicontrol('Style','slider','Position',pos_drsnik,'Max',4,'Value',0.1,'Callback','Prim31_Nicle_callb');

% Nariemo tekstovno polje, kjer se izpisuje as vzorenja
pos_text = pos_drsnik;
pos_text(1) = pos_drsnik(1)-50;
pos_text(2) = pos_drsnik(2)+pos_drsnik(4)+20;
pos_text(3) = pos_drsnik(3)+100;
pos_text(4) = 30;
tekst = ['Ts=0.1'];
roct=uicontrol('Style','text', 'Position',pos_text, 'String',tekst, 'FontSize',14);
