% Ilustracija nepovezave fazne (ne)minimalnosti zveznih in diskretnih sistemov
% Analitina reitev

clear all
close all
clc

%% Zvezni sistem fazno minimalen (trojni integrator) - nima nile na desni
syms s T t k z
Gz = 1/s^3
yz = ilaplace(Gz/s);
y = subs(yz,t,k*T);
Y = ztrans(y,k,z);
G = simple((z-1)/z*Y);
disp('1. primer - diskretna prenosna funkcija')
pretty(G)
nicle = solve(G);
disp('1. primer - nila diskretne prenosne funkcije')
pretty(nicle)


%% Zvezni sistem fazno neminimalen - ima nilo na desni (pri s = +0.5)
clear all
close all

syms s T t k z
Gz = (1-2*s)/(s+1)^2
yz = ilaplace(Gz/s);
y = subs(yz,t,k*T);
Y = ztrans(y,k,z);
G = simple((z-1)/z*Y);
[G_num,G_den]=numden(G);
G_num = collect(simple(G_num),z);
disp('2. primer - tevec diskretne prenosne funkcije')
pretty(G_num)
G_den = simple(G_den);
disp('2. primer - imenovalec diskretne prenosne funkcije')
pretty(G_den)

nicla = simple(solve(G_num,z));
disp('2. primer - nila diskretne prenosne funkcije')
pretty(nicla)
ezplot(nicla,[0 10])
grid
title('Odvisnost nile diskretne prenosne funkcije od asa vzorenja')
xlabel('Ts');
ylabel('nila')
disp('Pri katerem Ts nila vstopi v krog enote?')
solve(nicla+1) % poie T, kjer postane nila z=-1  